package pref;

import javax.swing.SwingUtilities;
import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JFrame;
import java.awt.Dimension;
import javax.swing.JLabel;
import java.awt.Font;
import javax.swing.SwingConstants;
import java.awt.Color;
import javax.swing.JList;
import javax.swing.ListSelectionModel;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import javax.swing.JButton;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JOptionPane;

import java.awt.event.KeyEvent;
import java.sql.ResultSet;
import java.util.ArrayList;

import javax.swing.JMenuItem;

public class PrefFrame extends JFrame {

	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;

	private JLabel jLabel = null;

	private JList jList = null;

	private JPanel jPanel = null;

	private JButton jButton = null;

	private JButton jButton1 = null;

	private JButton jButton2 = null;

	private JButton jButton3 = null;

	private JMenuBar jJMenuBar = null;

	private JMenu jMenu = null;

	private JMenu jMenu1 = null;

	private JMenu jMenu2 = null;

	private JMenuItem jMenuItem = null;

	private JMenuItem jMenuItem1 = null;

	private JMenuItem jMenuItem2 = null;

	private JMenuItem jMenuItem3 = null;

	private JMenuItem jMenuItem4 = null;

	private JMenuItem jMenuItem5 = null;
	
	private String[] tkn;

	/**
	 * This method initializes jList	
	 * 	
	 * @return javax.swing.JList	
	 */
	private JList getJList() {
		if (jList == null) {
			jList = new JList();
			jList.setFont(new Font("Dialog", Font.PLAIN, 14));
			jList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			jList.setForeground(Color.darkGray);
		}
		return jList;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			GridLayout gridLayout = new GridLayout();
			gridLayout.setRows(1);
			gridLayout.setColumns(4);
			jPanel = new JPanel();
			jPanel.setLayout(gridLayout);
			jPanel.add(getJButton(), null);
			jPanel.add(getJButton1(), null);
			jPanel.add(getJButton2(), null);
			jPanel.add(getJButton3(), null);
		}
		return jPanel;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("ǉ");
		}
		return jButton;
	}

	/**
	 * This method initializes jButton1	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setText("XV");
		}
		return jButton1;
	}

	/**
	 * This method initializes jButton2	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton2() {
		if (jButton2 == null) {
			jButton2 = new JButton();
			jButton2.setText("폜");
		}
		return jButton2;
	}

	/**
	 * This method initializes jButton3	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton3() {
		if (jButton3 == null) {
			jButton3 = new JButton();
			jButton3.setText("I");
			jButton3.setForeground(Color.red);
		}
		return jButton3;
	}

	/**
	 * This method initializes jJMenuBar	
	 * 	
	 * @return javax.swing.JMenuBar	
	 */
	private JMenuBar getJJMenuBar() {
		if (jJMenuBar == null) {
			jJMenuBar = new JMenuBar();
			jJMenuBar.add(getJMenu());
			jJMenuBar.add(getJMenu1());
			jJMenuBar.add(getJMenu2());
		}
		return jJMenuBar;
	}

	/**
	 * This method initializes jMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getJMenu() {
		if (jMenu == null) {
			jMenu = new JMenu();
			jMenu.setText("t@C(F)");
			jMenu.addSeparator();
			jMenu.setMnemonic(KeyEvent.VK_F);
			jMenu.add(getJMenuItem());
		}
		return jMenu;
	}

	/**
	 * This method initializes jMenu1	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getJMenu1() {
		if (jMenu1 == null) {
			jMenu1 = new JMenu();
			jMenu1.setText("ҏW(E)");
			jMenu1.setMnemonic(KeyEvent.VK_E);
			jMenu1.add(getJMenuItem1());
			jMenu1.add(getJMenuItem2());
			jMenu1.add(getJMenuItem3());
		}
		return jMenu1;
	}

	/**
	 * This method initializes jMenu2	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getJMenu2() {
		if (jMenu2 == null) {
			jMenu2 = new JMenu();
			jMenu2.setText("(S)");
			jMenu2.setMnemonic(KeyEvent.VK_S);
			jMenu2.add(getJMenuItem4());
			jMenu2.add(getJMenuItem5());
		}
		return jMenu2;
	}

	/**
	 * This method initializes jMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getJMenuItem() {
		if (jMenuItem == null) {
			jMenuItem = new JMenuItem();
			jMenuItem.setText("I(X)");
			jMenuItem.setMnemonic(KeyEvent.VK_X);
		}
		return jMenuItem;
	}

	/**
	 * This method initializes jMenuItem1	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getJMenuItem1() {
		if (jMenuItem1 == null) {
			jMenuItem1 = new JMenuItem();
			jMenuItem1.setText("ǉ(I)");
			jMenuItem1.setMnemonic(KeyEvent.VK_I);
		}
		return jMenuItem1;
	}

	/**
	 * This method initializes jMenuItem2	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getJMenuItem2() {
		if (jMenuItem2 == null) {
			jMenuItem2 = new JMenuItem();
			jMenuItem2.setText("XV(U)");
			jMenuItem2.setMnemonic(KeyEvent.VK_U);
		}
		return jMenuItem2;
	}

	/**
	 * This method initializes jMenuItem3	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getJMenuItem3() {
		if (jMenuItem3 == null) {
			jMenuItem3 = new JMenuItem();
			jMenuItem3.setText("폜(D)");
			jMenuItem3.setMnemonic(KeyEvent.VK_D);
		}
		return jMenuItem3;
	}

	/**
	 * This method initializes jMenuItem4	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getJMenuItem4() {
		if (jMenuItem4 == null) {
			jMenuItem4 = new JMenuItem();
			jMenuItem4.setText("(R)");
			jMenuItem4.setMnemonic(KeyEvent.VK_R);
		}
		return jMenuItem4;
	}

	/**
	 * This method initializes jMenuItem5	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getJMenuItem5() {
		if (jMenuItem5 == null) {
			jMenuItem5 = new JMenuItem();
			jMenuItem5.setText("S\(A)");
			jMenuItem5.setMnemonic(KeyEvent.VK_A);
		}
		return jMenuItem5;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO ꂽ\bhEX^u
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				PrefFrame thisClass = new PrefFrame();
				thisClass.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				thisClass.setVisible(true);
			}
		});
	}

	/**
	 * This is the default constructor
	 */
	public PrefFrame() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(250, 350);
		this.setJMenuBar(getJJMenuBar());
		this.setContentPane(getJContentPane());
		this.setTitle("s{}X^[");
		this.setLocationRelativeTo(null);
//		f[^\
		prefAll();
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel = new JLabel();
			jLabel.setText("JLabel");
			jLabel.setHorizontalAlignment(SwingConstants.CENTER);
			jLabel.setBackground(Color.white);
			jLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
			jLabel.setOpaque(true);
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(jLabel, BorderLayout.NORTH);
			jContentPane.add(getJList(), BorderLayout.CENTER);
			jContentPane.add(getJPanel(), BorderLayout.SOUTH);
		}
		return jContentPane;
	}

	private void prefDisplay (ResultSet rs) {
		tkn = null;
		ArrayList<String> listData = new ArrayList<String>();
		try {
			//ʃZbgf[^o next()Ŏ̍sɈړ
			int count = 0;
			while(rs.next()) {
				int prefCd = rs.getInt("PREF_CD");
				String prefName = rs.getString("PREF_NAME");
				listData.add(prefCd + "," + prefName);
				count++;
			}

			jList.setListData(listData.toArray());
			jLabel.setForeground(Color.BLUE);

			if(count == 0) {
				jLabel.setText("Y郌R[h܂B");
			}else{
				jLabel.setText(count + "\܂B");
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private void showExitDialog () {
		//I_CAO{bNX̕\
		int ret = JOptionPane.showConfirmDialog (jContentPane, "vOI܂H", "mF", JOptionPane.YES_NO_OPTION);

		if(ret == JOptionPane.YES_OPTION) {
			System.exit(0);
		}
	}

	private void prefInsert () {
		//ǉ
		SampleDb030 db = new SampleDb030();
		String message = "PREF_CD ͂ĂB";
		String title = "ǉ";
		try {

			String prefCd = JOptionPane.showInputDialog (jContentPane, message, title,JOptionPane.QUESTION_MESSAGE);

			if(prefCd != null && !prefCd.equals("")) {
				String message2 = "PREF_NAME ͂ĂB";
				String prefName = JOptionPane.showInputDialog (jContentPane, message2, title,JOptionPane.QUESTION_MESSAGE);

				if(prefName != null && !prefName.equals("")) {
					String mySql = "insert into T01Prefecture values(" + prefCd + ", '" + prefName + "')";
					System.out.println(mySql);

					db.open();
					int num = db.executeUpdate(mySql);
					prefAll();
					jLabel.setText("o^܂B");
				}
			}
		} catch (BadSqlException e) {
			jLabel.setText("o^ł܂łB");
			jLabel.setForeground(Color.RED);
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			db.close();
		}
	}

	private void prefUpdate () {
		//XV
		SampleDb030 db = new SampleDb030();
		String prefCd = (tkn != null) ? tkn[0] : null;
		String prefName = (tkn != null) ? tkn[1] : null;
		Object nameObj = null;

		try {
			if(prefCd != null) {
				String message = "u" + prefCd + "@" + prefName + "v\nV PREF_NAME ͂ĂB";
				String title = "XV";
				nameObj = JOptionPane.showInputDialog (jContentPane, message, title,JOptionPane.QUESTION_MESSAGE, null, null, prefName);
			}else{
				JOptionPane.showMessageDialog(jContentPane, "ɓs{IĂB");
			}

			if(nameObj != null) {
				prefName = (String)nameObj;
				String mySql = "update T01Prefecture set PREF_NAME = '" + prefName + "' where PREF_CD = " + prefCd;
				System.out.println(mySql);

				db.open();
				int num = db.executeUpdate(mySql);
				prefAll();
				jLabel.setText(num + "XV܂B");
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			db.close();
		}
	}

	private void prefDelete () {
		//폜
		SampleDb030 db = new SampleDb030();
		String prefCd = (tkn != null) ? tkn[0] : null;
		String prefName = (tkn != null) ? tkn[1] : null;
		int ret = -9;

		try {
			if(prefCd != null) {
				String message = "u" + prefCd + "@" + prefName + "v폜܂H";
				String title = "폜";
				ret = JOptionPane.showConfirmDialog (jContentPane, message, title, JOptionPane.OK_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE);
			}else{
				JOptionPane.showMessageDialog(jContentPane, "ɓs{IĂB");
			}

			if(ret == JOptionPane.OK_OPTION) {
				String mySql = "delete from T01Prefecture where PREF_CD = " + prefCd;
				System.out.println(mySql);

				db.open();
				int num = db.executeUpdate(mySql);
				prefAll();
				jLabel.setText(num + "폜܂B");
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			db.close();
		}

	}

	private void prefSearch () {
		//
		SampleDb030 db = new SampleDb030();
		String message = "PREF_NAME ̈ꕔ͂ĂB";
		String title = "";
		try {
			String prefName = JOptionPane.showInputDialog (jContentPane, message, title, JOptionPane.QUESTION_MESSAGE);

			if(prefName != null && !prefName.equals("")) {
				String mySql = "select * from T01Prefecture where PREF_NAME like '%" + prefName + "%'";
				System.out.println(mySql);

				db.open();
				ResultSet rs = db.executeQuery(mySql);
				prefDisplay(rs);
			}

		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			db.close();
		}

	}

	private void prefAll () {
		//S\

		//SampleDb030CX^X
		SampleDb030 db = new SampleDb030();

		try {
				String mySql = "select * from T01Prefecture order by PREF_CD";
				System.out.println(mySql);

				//f[^x[Xɐڑ
				db.open();
				//SQLs
				ResultSet rs = db.executeQuery(mySql);
				//f[^\
				prefDisplay(rs);

		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			//IuWFNg
			db.close();
		}

	}

}
